template<bool is_while, typename A, typename B,
         typename Actor1=NopActor, typename Actor2=NopActor>
class WhPa: public parser<WhPa<is_while, A,B> >
{
    typedef parser<WhPa<is_while, A,B> > base_t;
    const typename A::embed_t opt1;
    const typename B::embed_t opt2;
    const Actor1 act1;
    const Actor2 act2;
public:
    WhPa(const A& a, const B& b,
         Actor1 ac1=Actor1(),
         Actor2 ac2=Actor2())
        : base_t(), opt1(a.derived()), opt2(b.derived()), act1(ac1), act2(ac2) { }

    template<typename ScannerT>
    bool parse(ScannerT& scan) const
    {
        typename ScannerT::iterator begin = scan.pos(), middle = scan.pos();
        bool first = !is_while;
        act1(begin,begin);
        while(first || opt1.parse(scan))
        {
            first=false;
            if(!opt2.parse(scan)) { scan.revert(begin); return false; }
            act2(middle, scan.pos());
            middle = scan.pos();
        }
        return true;
    }
    const std::string what() const
    {
        if(is_while) return opt1.what();
        return opt2.what();
    }
};

template<typename A>
class WhPg
{
    const A& ref;
public:
    WhPg(const parser<A>& a) : ref(a.derived()) { }

    template<typename B>
    WhPa<true, A,Expecter<B> >
    operator[] (const parser<B>& b) const
      { return WhPa<true, A, Expecter<B> > (ref, b.expected()); }
};
template<typename A>
WhPg<A> while_p(const parser<A>& a) { return WhPg<A>(a); }



template<typename A,typename Actor1,typename Actor2>
class ForPg
{
    const A& ref;
    const Actor1& actor1;
    const Actor2& actor2;
public:
    ForPg(const parser<A>& a,
          const Actor1& ac1,
          const Actor2& ac2)
            : ref(a.derived()), actor1(ac1), actor2(ac2) { }

    template<typename B>
    WhPa<true, A,Expecter<B>, Actor1,Actor2>
    operator[] (const parser<B>& b) const
      { return WhPa<true, A, Expecter<B>, Actor1,Actor2> (ref, b.expected(), actor1,actor2); }
};
template<typename A, typename Actor1, typename Actor2>
ForPg<A,Actor1,Actor2>
    for_p(const Actor1& act1, const parser<A>& a,
          const Actor2& act2)
       { return ForPg<A,Actor1,Actor2>(a, act1, act2); }



template<typename A>
class DoPa
{
    const A& ref;
public:
    DoPa(const parser<A>& a) : ref(a.derived()) { }

    template<typename B>
    WhPa<false,B,Expecter<A> > while_p(const parser<B>& b)
      { return WhPa<false,B,Expecter<A> >(b.derived(), ref.expected()); }
};
static const class DoPg
{
public:
    DoPg() { }

    template<typename B>
    DoPa<B> operator[] (const parser<B>& b) const
      { return DoPa<B>(b); }
} do_p;
