#ifndef bqtQBlibBstringFunHH
#define bqtQBlibBstringFunHH

#include <qblib/types.hh>
#include <qblib/stringfun.hh>
#include <qblib/basfun.hh>

const BAS_STR B_FuncSPACE_S(long n);
const BAS_STR B_FuncSTRING_S(long n, const BAS_STR& s);
const BAS_STR B_FuncSTRING_S(long n, int i);
const BAS_STR B_FuncCHR_S(long n);
const BAS_STR B_FuncSTR_S(BAS_DBL d);
const BAS_STR B_FuncSTR_S(BAS_ULONG i);
const BAS_STR B_FuncSTR_S(BAS_UINT i);
const BAS_STR B_FuncSTR_S(BAS_UBYTE i);
const BAS_STR B_FuncSTR_S(BAS_LNG i);
const BAS_STR B_FuncSTR_S(BAS_INT i);
const BAS_STR B_FuncSTR_S(BAS_BYTE i);

const BAS_STR B_FuncHEX_S(BAS_DBL d);
const BAS_STR B_FuncHEX_S(BAS_ULONG i);
const BAS_STR B_FuncHEX_S(BAS_UINT i);
const BAS_STR B_FuncHEX_S(BAS_UBYTE i);
const BAS_STR B_FuncHEX_S(BAS_LNG i);
const BAS_STR B_FuncHEX_S(BAS_INT i);
const BAS_STR B_FuncHEX_S(BAS_BYTE i);

BAS_INT B_FuncASC(const BAS_STR& s);


int B_FuncINSTR(         const std::string& haystack, const std::string& needle);
int B_FuncINSTR(int pos, const std::string& haystack, const std::string& needle);

static inline const BAS_STR B_FuncHEX_S(BAS_SGN d) { return B_FuncHEX_S(BAS_DBL(d)); }
static inline const BAS_STR B_FuncSTR_S(BAS_SGN s) { return B_FuncSTR_S((BAS_DBL)s); }

static inline const BAS_STR B_FuncLEFT_S(const BAS_STR& s, int count) { return BasLEFTs(s,count); }
static inline const BAS_STR B_FuncRIGHT_S(const BAS_STR& s, int count) { return BasRIGHTs(s,count); }
static inline const BAS_STR B_FuncMID_S(const BAS_STR& s, int pos, int count=-1) { return BasMIDs(s,pos,count); }
static inline const BAS_STR B_FuncLTRIM_S(const BAS_STR& s) { return LTrim(s); }
static inline const BAS_STR B_FuncRTRIM_S(const BAS_STR& s) { return RTrim(s); }
static inline const BAS_STR B_FuncUCASE_S(const BAS_STR& s) { return UCase(s); }
static inline const BAS_STR B_FuncLCASE_S(const BAS_STR& s) { return LCase(s); }

static inline long B_FuncLEN(const BAS_STR& s) { return s.size(); }

#endif
