#include <vector>
#include <utility>

#include "gfx_api.hh"

class TerminalScreen: public Screen
{
    struct Page
    {
        std::vector<unsigned short> contents;
        std::pair<int,int> cursorpos;
    };
    std::vector<Page> pages;
    int apage, vpage, fgc, bgc;
public:
    TerminalScreen();
    virtual ~TerminalScreen();

    /* Terminal specific */
    virtual std::pair<int,int> GetCursorPos();

    virtual void SetCursorPos(const std::pair<int,int>& newpos);

    virtual void SetCursorVisibility(bool visible)
    {
    }

    virtual void SetCursorSize(int start, int stop)
    {
    }

    virtual int GetModeNumber() { return 0; }

    virtual void SetPages(int npages);
    virtual void SetAPage(int pageno);
    virtual void SetVPage(int pageno);

    virtual std::pair<int,int> GetWinSize();

    virtual std::pair<int,int> ReadScreen(int x,int y);

    virtual void SetWinSize(const std::pair<int,int>& newsize, bool approximate);
    virtual void OutS(const char* buffer, size_t nbytes);
    virtual void SetColor(int fg, int bg, int border);

    virtual void ScreenPOKE(int x,int y, int colorflag, int value);

    virtual void ClearEntireScreen();
    virtual void ClearText(int firstline, int lastline);

    void SizeChanged(const std::pair<int,int>& oldsize);
    void ReRenderVpage();
    void ScrollRegion(int firstline, int lastline, int direction);

    virtual void ValidateColor(int color);

    virtual void ClearGFXport() { } // nop
    virtual void SetPalette(int index, int value)
    {
        /* TODO */
    }
    virtual void Hline(int,int,int,unsigned) { B_ERROR(5); }
    virtual void Vline(int,int,int,unsigned) { B_ERROR(5); }
    virtual unsigned GetPixel(int,int) { B_ERROR(5); }
    virtual void SetPixel(int,int,unsigned) { B_ERROR(5); }
};

void Term_Init();
void Term_Done();
